Index: src/Actions/AtomAction/SaveSelectedAtomsAction.cpp
===================================================================
--- src/Actions/AtomAction/SaveSelectedAtomsAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/AtomAction/SaveSelectedAtomsAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -45,11 +45,6 @@
   if (params.filename.get().has_filename()) {
     // get suffix
-#if BOOST_VERSION >= 104600
       FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
       FilenamePrefix = params.filename.get().stem().string();
-#else
-      FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.get().stem();
-#endif
   } else {
     ELOG(1, "Output file does not have a suffix, cannot recognize format.");
Index: src/Actions/MoleculeAction/LoadAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LoadAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/MoleculeAction/LoadAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -55,11 +55,6 @@
     if (params.filename.get().has_filename()) {
       // get suffix
-#if BOOST_VERSION >= 104600
       FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
       FilenamePrefix = params.filename.get().stem().string();
-#else
-      FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.get().stem();
-#endif
     } else {
       ELOG(1, "Input file does not have a suffix, cannot recognize format.");
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -44,9 +44,5 @@
     LOG(0, "Storing adjacency to path " << params.adjacencyfile.get() << ".");
     // TODO: sollte stream nicht filename benutzen, besser fuer unit test
-#if BOOST_VERSION >= 104600
     mol->StoreAdjacencyToFile(params.adjacencyfile.get().leaf().string(), params.adjacencyfile.get().branch_path().string());
-#else
-    mol->StoreAdjacencyToFile(params.adjacencyfile.get().leaf(), params.adjacencyfile.get().branch_path().string());
-#endif
   }
   return Action::success;
Index: src/Actions/MoleculeAction/SaveBondsAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/MoleculeAction/SaveBondsAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -44,9 +44,5 @@
     LOG(0, "Storing bonds to path " << params.bondsfile.get() << ".");
     // TODO: sollte stream, nicht filenamen direkt nutzen, besser fuer unit tests
-#if BOOST_VERSION >= 104600
     mol->StoreBondsToFile(params.bondsfile.get().leaf().string(), params.bondsfile.get().branch_path().string());
-#else
-    mol->StoreBondsToFile(params.bondsfile.get().leaf(), params.bondsfile.get().branch_path().string());
-#endif
   }
   return Action::success;
Index: src/Actions/MoleculeAction/SaveSelectedMoleculesAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveSelectedMoleculesAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/MoleculeAction/SaveSelectedMoleculesAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -45,11 +45,6 @@
   if (params.filename.get().has_filename()) {
     // get suffix
-#if BOOST_VERSION >= 104600
       FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
       FilenamePrefix = params.filename.get().stem().string();
-#else
-      FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.get().stem();
-#endif
   } else {
     ELOG(1, "Output file does not have a suffix, cannot recognize format.");
Index: src/Actions/WorldAction/InputAction.cpp
===================================================================
--- src/Actions/WorldAction/InputAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/WorldAction/InputAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -52,11 +52,6 @@
   if (params.filename.get().has_filename()) {
     // get suffix
-#if BOOST_VERSION >= 104600
     FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
     FilenamePrefix = params.filename.get().stem().string();
-#else
-    FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
-    FilenamePrefix = params.filename.get().stem();
-#endif
     LOG(1, "Setting config file name prefix to " << FilenamePrefix << ".");
     parsers.SetOutputPrefixForAll(FilenamePrefix);
Index: src/Actions/WorldAction/OutputAsAction.cpp
===================================================================
--- src/Actions/WorldAction/OutputAsAction.cpp	(revision d0f3ba56533333c78a8145f2227a4b9e0b1214e0)
+++ src/Actions/WorldAction/OutputAsAction.cpp	(revision 1887bbc5b2069c9a1d8a81ac07736aa4322f5f0c)
@@ -46,11 +46,6 @@
   if (params.filename.get().has_filename()) {
     // get suffix
-#if BOOST_VERSION >= 104600
     FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
     FilenamePrefix = params.filename.get().stem().string();
-#else
-    FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
-    FilenamePrefix = params.filename.get().stem();
-#endif
   } else {
     ELOG(1, "Output file does not have a suffix, cannot recognize format.");