Index: tests/regression/Molecules/VerletIntegration/post/test.conf
===================================================================
--- tests/regression/Molecules/VerletIntegration/post/test.conf	(revision 0d97b4b7169d73c32a31da6e1baa10b740848f7e)
+++ tests/regression/Molecules/VerletIntegration/post/test.conf	(revision 4882d52fd77a2eb51b75de4188f4386a1dbad67f)
@@ -71,25 +71,25 @@
 Ion_Type2	3	6	1.0	3	3	12.01100000000	Carbon	C
 #Ion_TypeNr._Nr.R[0]    R[1]    R[2]    MoveType (0 MoveIon, 1 FixedIon)
-Ion_Type1_1	9.782085945	2.645886050	2.645886050	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 0
-Ion_Type1_2	9.782085945	2.645886050	4.425886024	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 1
-Ion_Type1_3	10.672039608	3.904536878	3.535886037	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 2
-Ion_Type1_4	8.532785963	4.787886018	2.645886050	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 3
-Ion_Type1_5	8.532785963	4.787886018	4.425886024	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 4
-Ion_Type1_6	6.393632318	3.904536877	3.535886037	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 5
-Ion_Type1_7	7.283585982	2.645886050	2.645886050	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 6
-Ion_Type1_8	7.283585982	2.645886050	4.425886024	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 7
-Ion_Type2_1	9.782085945	3.275186040	3.535886037	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 8
-Ion_Type2_2	8.532785963	4.158586027	3.535886037	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 9
-Ion_Type2_3	7.283585982	3.275186040	3.535886037	0	9.980023e-02	0.000000e+00	0.000000e+00	 # molecule nr 10
+Ion_Type1_1	9.782085945	2.645886050	2.645886050	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 0
+Ion_Type1_2	9.782085945	2.645886050	4.425886024	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 1
+Ion_Type1_3	10.672039608	3.904536878	3.535886037	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 2
+Ion_Type1_4	8.532785963	4.787886018	2.645886050	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 3
+Ion_Type1_5	8.532785963	4.787886018	4.425886024	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 4
+Ion_Type1_6	6.393632318	3.904536877	3.535886037	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 5
+Ion_Type1_7	7.283585982	2.645886050	2.645886050	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 6
+Ion_Type1_8	7.283585982	2.645886050	4.425886024	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 7
+Ion_Type2_1	9.782085945	3.275186040	3.535886037	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 8
+Ion_Type2_2	8.532785963	4.158586027	3.535886037	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 9
+Ion_Type2_3	7.283585982	3.275186040	3.535886037	0	1.000000e-01	0.000000e+00	0.000000e+00	 # molecule nr 10
 
-Ion_Type1_1	9.783080985	2.645881090	2.645886050	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 0
-Ion_Type1_2	9.783080985	2.645881090	4.425886024	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 1
-Ion_Type1_3	10.673034648	3.904531918	3.535886037	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 2
-Ion_Type1_4	8.533781003	4.787881058	2.645886050	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 3
-Ion_Type1_5	8.533781003	4.787881058	4.425886024	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 4
-Ion_Type1_6	6.394627358	3.904531917	3.535886037	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 5
-Ion_Type1_7	7.284581022	2.645881090	2.645886050	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 6
-Ion_Type1_8	7.284581022	2.645881090	4.425886024	0	9.900794e-02	-9.920635e-04	0.000000e+00	 # molecule nr 7
-Ion_Type2_1	9.783085529	3.275185624	3.535886037	0	9.991674e-02	-8.325701e-05	0.000000e+00	 # molecule nr 8
-Ion_Type2_2	8.533785547	4.158585611	3.535886037	0	9.991674e-02	-8.325701e-05	0.000000e+00	 # molecule nr 9
-Ion_Type2_3	7.284585566	3.275185624	3.535886037	0	9.991674e-02	-8.325701e-05	0.000000e+00	 # molecule nr 10
+Ion_Type1_1	9.783090905	2.645891010	2.645886050	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 0
+Ion_Type1_2	9.783090905	2.645891010	4.425886024	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 1
+Ion_Type1_3	10.673044568	3.904541838	3.535886037	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 2
+Ion_Type1_4	8.533790923	4.787890978	2.645886050	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 3
+Ion_Type1_5	8.533790923	4.787890978	4.425886024	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 4
+Ion_Type1_6	6.394637278	3.904541837	3.535886037	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 5
+Ion_Type1_7	7.284590942	2.645891010	2.645886050	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 6
+Ion_Type1_8	7.284590942	2.645891010	4.425886024	0	1.002953e-01	4.950408e-04	0.000000e+00	 # molecule nr 7
+Ion_Type2_1	9.783086361	3.275186456	3.535886037	0	9.984178e-02	4.154535e-05	0.000000e+00	 # molecule nr 8
+Ion_Type2_2	8.533786379	4.158586443	3.535886037	0	9.984178e-02	4.154535e-05	0.000000e+00	 # molecule nr 9
+Ion_Type2_3	7.284586398	3.275186456	3.535886037	0	9.984178e-02	4.154535e-05	0.000000e+00	 # molecule nr 10
Index: tests/regression/Molecules/VerletIntegration/testsuite-molecules-verlet-integration.at
===================================================================
--- tests/regression/Molecules/VerletIntegration/testsuite-molecules-verlet-integration.at	(revision 0d97b4b7169d73c32a31da6e1baa10b740848f7e)
+++ tests/regression/Molecules/VerletIntegration/testsuite-molecules-verlet-integration.at	(revision 4882d52fd77a2eb51b75de4188f4386a1dbad67f)
@@ -25,5 +25,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/VerletIntegration/pre/test.forces .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  --select-all-atoms -P test.forces --MDSteps 1 --deltat 0.01 --keep-fixed-CenterOfMass 0], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-all-atoms --verlet-integration --forces-file test.forces --MDSteps 1 --deltat 0.01 --keep-fixed-CenterOfMass 0], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/VerletIntegration/post/test.conf], 0, [ignore], [ignore])
 
@@ -39,5 +39,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/VerletIntegration/pre/test.forces .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  --select-all-atoms -P test.forces --MDSteps 1 --deltat 0.01 --keep-fixed-CenterOfMass 0 --undo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-all-atoms --verlet-integration --forces-file test.forces --MDSteps 1 --deltat 0.01 --keep-fixed-CenterOfMass 0 --undo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/VerletIntegration/post/test.conf], 0, [ignore], [ignore])
 
@@ -53,5 +53,5 @@
 AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Molecules/VerletIntegration/pre/test.forces .], 0)
 AT_CHECK([chmod u+w $file], 0)
-AT_CHECK([../../molecuilder -i $file  --select-all-atoms -P test.forces --MDSteps 1 --deltat 0.01 --keep-fixed-CenterOfMass 0 --undo --redo], 0, [stdout], [stderr])
+AT_CHECK([../../molecuilder -i $file --select-all-atoms --verlet-integration --forces-file test.forces --MDSteps 1 --deltat 0.01 --keep-fixed-CenterOfMass 0 --undo --redo], 0, [stdout], [stderr])
 AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Molecules/VerletIntegration/post/test.conf], 0, [ignore], [ignore])
 